Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1539)
@@ -6,231 +6,544 @@
 using namespace std;
 
+extern std::map<std::pair<int, int>, MPI_Group* > * tag_group_map;
+
+extern std::map<int, std::pair<ep_lib::MPI_Comm*, std::pair<int, int> > > * tag_comm_map;
+
+extern MPI_Group MPI_GROUP_WORLD;
+
 namespace ep_lib
 {
+
   int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm)
   {
-    assert(local_comm->is_ep);
-
+    if(!local_comm->is_ep) return MPI_Intercomm_create_mpi(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
+
+    int ep_rank = local_comm->ep_comm_ptr->size_rank_info[0].first;
+    
+    
+    // check if local leaders are in the same mpi proc
+    // by checking their mpi_rank in peer_comm
+    
+    int mpi_rank_of_leader[2];
+    
+    if(ep_rank == local_leader)
+    {
+      mpi_rank_of_leader[0] = peer_comm->ep_comm_ptr->size_rank_info[2].first;
+      mpi_rank_of_leader[1] = peer_comm->ep_rank_map->at(remote_leader).second;      
+    }
+    
+    MPI_Bcast(mpi_rank_of_leader, 2, MPI_INT, local_leader, local_comm);
+    
+    if(mpi_rank_of_leader[0] != mpi_rank_of_leader[1])
+    {
+      Debug("calling MPI_Intercomm_create_kernel\n");
+      return MPI_Intercomm_create_endpoint(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
+    }
+    else
+    {
+      printf("local leaders are in the same MPI proc. Routine not yet implemented\n");
+      MPI_Abort(local_comm, 0);
+    }
+  }
+  
+  
+  
+  int MPI_Intercomm_create_endpoint(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm)
+  {
     int ep_rank, ep_rank_loc, mpi_rank;
     int ep_size, num_ep, mpi_size;
 
-    ep_rank = local_comm->ep_comm_ptr->size_rank_info[0].first;
+    ep_rank     = local_comm->ep_comm_ptr->size_rank_info[0].first;
     ep_rank_loc = local_comm->ep_comm_ptr->size_rank_info[1].first;
-    mpi_rank = local_comm->ep_comm_ptr->size_rank_info[2].first;
-    ep_size = local_comm->ep_comm_ptr->size_rank_info[0].second;
-    num_ep = local_comm->ep_comm_ptr->size_rank_info[1].second;
-    mpi_size = local_comm->ep_comm_ptr->size_rank_info[2].second;
-
-
-    MPI_Barrier(local_comm);
-
-    int leader_ranks_in_peer[3];  // local_leader_rank_in_peer
-                                  // remote_leader_rank_in_peer
-                                  // size of peer
-
-    if(ep_rank == local_leader)
-    {
-      MPI_Comm_rank(peer_comm, &leader_ranks_in_peer[0]);
-      leader_ranks_in_peer[1] = remote_leader;
-      MPI_Comm_size(peer_comm, &leader_ranks_in_peer[2]);
-    }
-
-    MPI_Bcast(leader_ranks_in_peer, 3, MPI_INT, local_leader, local_comm);
-
-    if(leader_ranks_in_peer[0] != leader_ranks_in_peer[2])
-    {
-      Debug("calling MPI_Intercomm_create_kernel\n");
-      return MPI_Intercomm_create_kernel(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
-    }
-
-    else
-    {
-      if(leader_ranks_in_peer[2] == 1)
-      {
-        Debug("calling MPI_Intercomm_create_unique\n");
-        return MPI_Intercomm_create_unique_leader(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm); 
+    mpi_rank    = local_comm->ep_comm_ptr->size_rank_info[2].first;
+    ep_size     = local_comm->ep_comm_ptr->size_rank_info[0].second;
+    num_ep      = local_comm->ep_comm_ptr->size_rank_info[1].second;
+    mpi_size    = local_comm->ep_comm_ptr->size_rank_info[2].second;
+
+    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+    // step 1 : local leaders exchange ep_size, leader_rank_in_peer, leader_rank_in_peer_mpi, leader_rank_in_world. //
+    //          local leaders bcast results to all ep in local_comm                                                 //
+    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+
+    bool is_local_leader = ep_rank==local_leader? true: false;
+    
+    
+    int local_leader_rank_in_peer;
+    int local_leader_rank_in_peer_mpi;
+    int local_leader_rank_in_world;
+
+    int remote_ep_size;
+    int remote_leader_rank_in_peer;
+    int remote_leader_rank_in_peer_mpi;
+    int remote_leader_rank_in_world;
+
+    int send_quadruple[4];
+    int recv_quadruple[4];
+
+
+    if(is_local_leader)
+    {
+      MPI_Comm_rank(peer_comm, &local_leader_rank_in_peer);
+      ::MPI_Comm_rank(to_mpi_comm(peer_comm->mpi_comm), &local_leader_rank_in_peer_mpi);
+      ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &local_leader_rank_in_world);
+
+      send_quadruple[0] = ep_size;
+      send_quadruple[1] = local_leader_rank_in_peer;
+      send_quadruple[2] = local_leader_rank_in_peer_mpi;
+      send_quadruple[3] = local_leader_rank_in_world;
+
+      MPI_Request request;
+      MPI_Status status;
+
+
+      if(remote_leader > local_leader_rank_in_peer)
+      {
+        MPI_Isend(send_quadruple, 4, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+       
+        MPI_Irecv(recv_quadruple, 4, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+      else
+      {
+        MPI_Irecv(recv_quadruple, 4, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+          
+        MPI_Isend(send_quadruple, 4, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+
+      remote_ep_size                 = recv_quadruple[0];
+      remote_leader_rank_in_peer     = recv_quadruple[1];
+      remote_leader_rank_in_peer_mpi = recv_quadruple[2];
+      remote_leader_rank_in_world    = recv_quadruple[3];
+#ifdef _showinfo
+      printf("peer_rank = %d, packed exchange OK\n", local_leader_rank_in_peer);
+#endif
+    }
+
+    MPI_Bcast(send_quadruple, 4, MPI_INT, local_leader, local_comm);
+    MPI_Bcast(recv_quadruple, 4, MPI_INT, local_leader, local_comm);
+
+    if(!is_local_leader)
+    {
+      local_leader_rank_in_peer     = send_quadruple[1];
+      local_leader_rank_in_peer_mpi = send_quadruple[2];
+      local_leader_rank_in_world    = send_quadruple[3];
+
+      remote_ep_size                 = recv_quadruple[0];
+      remote_leader_rank_in_peer     = recv_quadruple[1];
+      remote_leader_rank_in_peer_mpi = recv_quadruple[2];
+      remote_leader_rank_in_world    = recv_quadruple[3];
+    }
+
+
+#ifdef _showinfo
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, ep_size = %d, remote_ep_size = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, ep_size, remote_ep_size);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm); 
+#endif
+
+    ///////////////////////////////////////////////////////////////////
+    // step 2 : gather ranks in world for both local and remote comm //
+    ///////////////////////////////////////////////////////////////////
+
+    int rank_in_world;
+    ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &rank_in_world);
+
+    int *ranks_in_world_local  = new int[ep_size];
+    int *ranks_in_world_remote = new int[remote_ep_size];
+
+    MPI_Allgather(&rank_in_world, 1, MPI_INT, ranks_in_world_local, 1, MPI_INT, local_comm);
+
+    if(is_local_leader)
+    {
+      MPI_Request request;
+      MPI_Status status;
+
+      if(remote_leader > local_leader_rank_in_peer)
+      {
+        MPI_Isend(ranks_in_world_local,  ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+       
+        MPI_Irecv(ranks_in_world_remote, remote_ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+      else
+      {
+        MPI_Irecv(ranks_in_world_remote, remote_ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+          
+        MPI_Isend(ranks_in_world_local,  ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+#ifdef _showinfo
+      printf("peer_rank = %d, ranks_in_world exchange OK\n", local_leader_rank_in_peer);
+#endif
+    }
+
+    MPI_Bcast(ranks_in_world_remote, remote_ep_size, MPI_INT, local_leader, local_comm);
+
+#ifdef _showinfo
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+
+    if(remote_leader == 4)
+    {
+      for(int i=0; i<ep_size; i++)
+      {
+        if(ep_rank == i)
+        {
+          printf("peer_rank = %d, ranks_in_world_local = \n", peer_comm->ep_comm_ptr->size_rank_info[0].first);
+          for(int i=0; i<ep_size; i++)
+          {
+            printf("%d\t", ranks_in_world_local[i]);
+          }
+    
+          printf("\npeer_rank = %d, ranks_in_world_remote = \n", peer_comm->ep_comm_ptr->size_rank_info[0].first);
+          for(int i=0; i<remote_ep_size; i++)
+          {
+            printf("%d\t", ranks_in_world_remote[i]);
+          }
+          printf("\n");
+         
+        }
         
-      }
-      else
-      {
-        Debug("calling MPI_Intercomm_create_world\n");
-        return MPI_Intercomm_create_from_world(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);   
-      }
+        MPI_Barrier(local_comm);
+        MPI_Barrier(local_comm);
+        MPI_Barrier(local_comm);
+      }
+    }
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    
+    if(remote_leader == 13)
+    {
+      for(int i=0; i<ep_size; i++)
+      {
+        if(ep_rank == i)
+        {
+          printf("peer_rank = %d, ranks_in_world_local = \n", peer_comm->ep_comm_ptr->size_rank_info[0].first);
+          for(int i=0; i<ep_size; i++)
+          {
+            printf("%d\t", ranks_in_world_local[i]);
+          }
+    
+          printf("\npeer_rank = %d, ranks_in_world_remote = \n", peer_comm->ep_comm_ptr->size_rank_info[0].first);
+          for(int i=0; i<remote_ep_size; i++)
+          {
+            printf("%d\t", ranks_in_world_remote[i]);
+          }
+          printf("\n");
+         
+        }
+        
+        MPI_Barrier(local_comm);
+        MPI_Barrier(local_comm);
+        MPI_Barrier(local_comm);
+      }
+    }
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+
+#endif
+
+    //////////////////////////////////////////////////////////////
+    // step 3 : determine the priority and ownership of each ep //
+    //////////////////////////////////////////////////////////////
+
+    bool priority = local_leader_rank_in_peer < remote_leader_rank_in_peer? true : false;
+
+
+    int ownership = priority;
+
+    if(rank_in_world == ranks_in_world_local[local_leader]) ownership = 1;
+    if(rank_in_world == remote_leader_rank_in_world)   ownership = 0;
+    
+
+#ifdef _showinfo
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, priority = %d, local_leader_rank_in_peer = %d, remote_leader_rank_in_peer = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, priority, local_leader_rank_in_peer, remote_leader_rank_in_peer);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+#endif
+
+    
+#ifdef _showinfo
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, priority = %d, ownership = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, priority, ownership);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+#endif
+
+    //////////////////////////////////////////////////////
+    // step 4 : extract local_comm and create intercomm //
+    //////////////////////////////////////////////////////
+
+    bool is_involved = is_local_leader || (!is_local_leader && ep_rank_loc == 0 && rank_in_world != local_leader_rank_in_world);
+
+#ifdef _showinfo
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, is_involved = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, is_involved);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+
+#endif
+
+    if(is_involved)
+    {
+      ::MPI_Group local_group;
+      ::MPI_Group extracted_group;
+      ::MPI_Comm extracted_comm;
+
+
+      ::MPI_Comm_group(to_mpi_comm(local_comm->mpi_comm), &local_group);
+
+      int *ownership_list = new int[mpi_size];
+      int *mpi_rank_list = new int[mpi_size];
+
+      ::MPI_Allgather(&ownership, 1, to_mpi_type(MPI_INT), ownership_list, 1, to_mpi_type(MPI_INT), to_mpi_comm(local_comm->mpi_comm));
+      ::MPI_Allgather(&mpi_rank,  1, to_mpi_type(MPI_INT), mpi_rank_list,  1, to_mpi_type(MPI_INT), to_mpi_comm(local_comm->mpi_comm));
+
       
-    }
-
-
-
-
-
-    int leader_ranks[6]; //! 0: rank in world, 1: mpi_size, 2: rank_in_peer.
-                         //! 3, 4, 5 : remote
-
-    bool is_decider = false;
-
-
-    if(ep_rank == local_leader)
-    {
-      MPI_Comm_rank(MPI_COMM_WORLD, &leader_ranks[0]);
-
-      leader_ranks[1] = mpi_size;
-      MPI_Comm_rank(peer_comm, &leader_ranks[2]);
-
-      MPI_Request request[2];
-      MPI_Status status[2];
-
-      MPI_Isend(&leader_ranks[0], 3, MPI_INT, remote_leader, tag, peer_comm, &request[0]);
-      MPI_Irecv(&leader_ranks[3], 3, MPI_INT, remote_leader, tag, peer_comm, &request[1]);
-
-      MPI_Waitall(2, request, status);
-
-    }
-
-
-    MPI_Bcast(leader_ranks, 6, MPI_INT, local_leader, local_comm);
-
-    
-    MPI_Barrier(local_comm);
-    
-
-    if(leader_ranks[0] == leader_ranks[3])
-    {
-      if( leader_ranks[1] * leader_ranks[4] == 1)
-      {
-        if(ep_rank == local_leader) printf("calling MPI_Intercomm_create_unique_leader\n");
-        local_comm->ep_comm_ptr->comm_label = -99;
-
-        return MPI_Intercomm_create_unique_leader(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
-      }
-      else // leader_ranks[1] * leader_ranks[4] != 1
-      {
-        // change leader
-        int new_local_leader;
-
-        if(leader_ranks[2] < leader_ranks[5])
+      int n=0;
+      for(int i=0; i<mpi_size; i++)
+      { 
+        n+=ownership_list[i];
+      }
+
+      int *new_mpi_rank_list = new int[n];
+      int j=0;
+      for(int i=0; i<mpi_size; i++)
+      { 
+        if(ownership_list[i] !=0)
         {
-          if(leader_ranks[1] > 1) //! change leader
+          new_mpi_rank_list[j++] = mpi_rank_list[i];
+        }
+      }
+
+
+      ::MPI_Group_incl(local_group, n, new_mpi_rank_list, &extracted_group);
+
+      ::MPI_Comm_create(to_mpi_comm(local_comm->mpi_comm), extracted_group, &extracted_comm);
+
+      ::MPI_Comm mpi_inter_comm;
+
+      int local_leader_rank_in_extracted_comm;
+
+      if(is_local_leader)
+      {
+        ::MPI_Comm_rank(extracted_comm, &local_leader_rank_in_extracted_comm);
+      }
+
+      ::MPI_Bcast(&local_leader_rank_in_extracted_comm, 1, to_mpi_type(MPI_INT), local_comm->ep_rank_map->at(local_leader).second, to_mpi_comm(local_comm->mpi_comm));
+
+      ::MPI_Comm *intracomm = new ::MPI_Comm;
+      bool is_real_involved = ownership && extracted_comm != to_mpi_comm(MPI_COMM_NULL->mpi_comm);
+
+      if(is_real_involved)
+      {
+        ::MPI_Intercomm_create(extracted_comm, local_leader_rank_in_extracted_comm, to_mpi_comm(peer_comm->mpi_comm), remote_leader_rank_in_peer_mpi, tag, &mpi_inter_comm);
+        ::MPI_Intercomm_merge(mpi_inter_comm, !priority, intracomm);
+      }
+        
+        
+
+      ////////////////////////////////////
+      // step 5 :: determine new num_ep //
+      ////////////////////////////////////
+
+      int num_ep_count=0;
+
+      for(int i=0; i<ep_size; i++)
+      {
+        if(rank_in_world == ranks_in_world_local[i])
+          num_ep_count++;
+      }
+      
+      for(int i=0; i<remote_ep_size; i++)
+      {
+        if(rank_in_world == ranks_in_world_remote[i])
+          num_ep_count++;
+      }
+
+
+      ///////////////////////////////////////////////////
+      // step 6 : create endpoints from extracted_comm //
+      ///////////////////////////////////////////////////
+
+      if(is_real_involved)
+      {
+        MPI_Comm *ep_comm;
+        MPI_Info info;
+        MPI_Comm_create_endpoints(intracomm, num_ep_count, info, ep_comm);
+      
+#ifdef _showinfo
+        printf("new ep_comm->ep_comm_ptr->intercomm->mpi_inter_comm = %p\n", mpi_inter_comm);
+#endif
+
+        #pragma omp critical (write_to_tag_list)      
+        intercomm_list.push_back(make_pair( make_pair(tag, min(local_leader_rank_in_world, remote_leader_rank_in_world)) , make_pair(ep_comm , make_pair(num_ep_count, 0))));
+        #pragma omp flush
+#ifdef _showinfo
+        for(int i=0; i<num_ep_count; i++)
+          printf("peer_rank = %d, ep_comm = %p, ep_comm[%d] -> new_ep_rank = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, ep_comm, i, ep_comm[i]->ep_comm_ptr->size_rank_info[0].first);
+#endif  
+        ::MPI_Comm_free(intracomm);
+        delete intracomm;
+      }
+
+
+      delete ownership_list;
+      delete mpi_rank_list;
+      delete new_mpi_rank_list;
+
+    }
+
+    int repeated=0;
+    for(int i=0; i<remote_ep_size; i++)
+    {
+      if(rank_in_world == ranks_in_world_remote[i])
+        repeated++;
+    }
+
+    int new_ep_rank_loc = ownership==1? ep_rank_loc : ep_rank_loc+repeated;
+
+#ifdef _showinfo
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, ep_rank_loc = %d, ownership = %d, repeated = %d, new_ep_rank_loc = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, ep_rank_loc, ownership, repeated, new_ep_rank_loc);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+
+#endif
+
+
+    #pragma omp flush
+    #pragma omp critical (read_from_intercomm_list)
+    {
+      bool flag=true;
+      while(flag)
+      {
+        for(std::list<std::pair<std::pair<int, int> , std::pair<MPI_Comm * , std::pair<int, int> > > >::iterator iter = intercomm_list.begin(); iter!=intercomm_list.end(); iter++)
+        {
+          if(iter->first == make_pair(tag, min(local_leader_rank_in_world, remote_leader_rank_in_world)))
           {
-            // change leader
-            is_decider = true;
-            int target = local_comm->ep_rank_map->at(local_leader).second;
-            {
-              for(int i=0; i<ep_size; i++)
-              {
-                if(local_comm->ep_rank_map->at(i).second != target && local_comm->ep_rank_map->at(i).first == 0)
-                {
-                  new_local_leader = i;
-                  break;
-                }
-              }
-            }
-          }
-          else
-          {
-            new_local_leader = local_leader;
+            *newintercomm = iter->second.first[new_ep_rank_loc];
+            
+            iter->second.second.second++;
+            
+            if(iter->second.second.first == iter->second.second.second)
+              intercomm_list.erase(iter);
+
+            flag = false;
+            break; 
           }
         }
-        else
-        {
-          if(leader_ranks[4] == 1)
-          {
-            // change leader
-            is_decider = true;
-            int target = local_comm->ep_rank_map->at(local_leader).second;
-            {
-              for(int i=0; i<ep_size; i++)
-              {
-                if(local_comm->ep_rank_map->at(i).second != target && local_comm->ep_rank_map->at(i).first == 0)
-                {
-                  new_local_leader = i;
-                  break;
-                }
-              }
-            }
-          }
-          else
-          {
-            new_local_leader = local_leader;
-          }
-        }
-
-
-        int new_tag_in_world;
-
-        int leader_in_world[2];
-
-
-        if(is_decider)
-        {
-          if(ep_rank == new_local_leader)
-          {
-            new_tag_in_world = TAG++;
-          }
-          MPI_Bcast(&new_tag_in_world, 1, MPI_INT, new_local_leader, local_comm);
-          if(ep_rank == local_leader) MPI_Send(&new_tag_in_world, 1, MPI_INT, remote_leader, tag, peer_comm);
-        }
-        else
-        {
-          if(ep_rank == local_leader)
-          {
-            MPI_Status status;
-            MPI_Recv(&new_tag_in_world, 1, MPI_INT, remote_leader, tag, peer_comm, &status);
-          }
-          MPI_Bcast(&new_tag_in_world, 1, MPI_INT, new_local_leader, local_comm);
-        }
-
-
-        if(ep_rank == new_local_leader)
-        {
-          ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &leader_in_world[0]);
-        }
-
-        MPI_Bcast(&leader_in_world[0], 1, MPI_INT, new_local_leader, local_comm);
-
-
-        if(ep_rank == local_leader)
-        {
-          MPI_Request request[2];
-          MPI_Status status[2];
-
-          MPI_Isend(&leader_in_world[0], 1, MPI_INT, remote_leader, tag, peer_comm, &request[0]);
-          MPI_Irecv(&leader_in_world[1], 1, MPI_INT, remote_leader, tag, peer_comm, &request[1]);
-
-          MPI_Waitall(2, request, status);
-        }
-
-        MPI_Bcast(&leader_in_world[1], 1, MPI_INT, local_leader, local_comm);
-
-        local_comm->ep_comm_ptr->comm_label = tag;
-
-        if(ep_rank == local_leader) printf("calling MPI_Intercomm_create_from_world\n");
-
-        return MPI_Intercomm_create_from_world(local_comm, new_local_leader, MPI_COMM_WORLD->mpi_comm, leader_in_world[1], new_tag_in_world, newintercomm);
-        
-      }
-    }
-
-    
-
+      }
+    }
+    
+
+
+#ifdef _showinfo
+
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+    printf("peer_rank = %d, test_rank = %d\n", peer_comm->ep_comm_ptr->size_rank_info[0].first, (*newintercomm)->ep_comm_ptr->size_rank_info[0].first);
+    MPI_Barrier(peer_comm);
+    MPI_Barrier(peer_comm);
+
+#endif
+
+    //////////////////////////////////////////////////////////
+    // step 7 : create intercomm_rank_map for local leaders //
+    //////////////////////////////////////////////////////////
+
+    (*newintercomm)->is_intercomm = true;
+    
+    (*newintercomm)->inter_rank_map = new INTER_RANK_MAP;
+    
+    
+    int rank_info[2];
+    rank_info[0] = ep_rank;
+    rank_info[1] = (*newintercomm)->ep_comm_ptr->size_rank_info[0].first;
+
+#ifdef _showinfo
+    printf("priority = %d, ep_rank = %d, new_ep_rank = %d\n", priority, rank_info[0], rank_info[1]);
+#endif
+
+    int *local_rank_info = new int[2*ep_size];
+    int *remote_rank_info = new int[2*remote_ep_size];
+
+    MPI_Allgather(rank_info, 2, MPI_INT, local_rank_info, 2, MPI_INT, local_comm);
+
+    if(is_local_leader)
+    {
+      MPI_Request request;
+      MPI_Status status;
+
+      if(priority)
+      {
+        MPI_Isend(local_rank_info, 2*ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+       
+        MPI_Irecv(remote_rank_info, 2*remote_ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+      else
+      {
+        MPI_Irecv(remote_rank_info, 2*remote_ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+          
+        MPI_Isend(local_rank_info, 2*ep_size, MPI_INT, remote_leader, tag, peer_comm, &request);
+        MPI_Wait(&request, &status);
+      }
+    }
+
+    MPI_Bcast(remote_rank_info, 2*remote_ep_size, MPI_INT, local_leader, local_comm);
+
+    for(int i=0; i<remote_ep_size; i++)
+    {
+      (*newintercomm)->inter_rank_map->insert(make_pair(remote_rank_info[2*i], remote_rank_info[2*i+1]));
+    }
+    
+    (*newintercomm)->ep_comm_ptr->size_rank_info[0] = local_comm->ep_comm_ptr->size_rank_info[0];
+
+    
+    delete[] local_rank_info;
+    delete[] remote_rank_info;
+    delete[] ranks_in_world_local;
+    delete[] ranks_in_world_remote;
+    /*
+    if((*newintercomm)->ep_comm_ptr->size_rank_info[0].second == 1)
+    {
+      for(INTER_RANK_MAP::iterator it = (*newintercomm)->inter_rank_map->begin(); it != (*newintercomm)->inter_rank_map->end(); it++)
+      {
+        printf("inter_rank_map[%d] = %d\n", it->first, it->second);
+      }
+    }
+    */
+    
+ 
   }
-
-  int MPI_Comm_test_inter(MPI_Comm comm, int *flag)
+    
+  
+  
+  int MPI_Intercomm_create_mpi(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm)
   {
-    *flag = false;
-    if(comm->is_ep)
-    {
-      *flag = comm->is_intercomm;
-      return 0;
-    } 
-    else if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL->mpi_comm))
-    {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
-      
-      ::MPI_Comm_test_inter(mpi_comm, flag);
-      return 0;  
-    }
-    return 0;
+    printf("MPI_Intercomm_create_mpi not yet implemented\n");
+    MPI_Abort(local_comm, 0);
   }
 
-
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp	(revision 1539)
@@ -12,4 +12,10 @@
 
 
+std::map<std::pair<int, int>, MPI_Group* > * tag_group_map = 0;
+
+std::map<int, std::pair<ep_lib::MPI_Comm*, std::pair<int, int> > > * tag_comm_map = 0;
+
+
+MPI_Group MPI_GROUP_WORLD;
 
 namespace ep_lib
@@ -26,20 +32,5 @@
 
   int get_ep_rank(MPI_Comm comm, int ep_rank_loc, int mpi_rank)
-  {
-    if(comm->is_intercomm)
-    {
-      for(std::map<int, std::pair< int, std::pair<int, int> > >::iterator it = comm->ep_comm_ptr->intercomm->intercomm_rank_map->begin(); it != comm->ep_comm_ptr->intercomm->intercomm_rank_map->end(); it++)
-      {
-        if(   ( it->second.first  == ep_rank_loc )
-           && ( it->second.second.first == mpi_rank ) )
-        {
-          return it->first;
-        }
-      }
-      printf("rank not find for EP_intercomm\n");
-      int err;
-      return MPI_Abort(comm, err);
-    }
-    
+  {    
     for(std::map<int, std::pair<int, int> >::iterator it = comm->ep_rank_map->begin(); it != comm->ep_rank_map->end(); it++)
     {
@@ -51,6 +42,5 @@
     }
     printf("rank not find for EP_intracomm\n");
-    int err;
-    return MPI_Abort(comm, err);
+    return MPI_Abort(comm, 0);
   }
   
@@ -64,5 +54,10 @@
   {
     return ::MPI_Wtime();
-
+  }
+
+  int MPI_Comm_test_inter(MPI_Comm comm, int *flag)
+  {
+    if(comm->is_ep) return *flag = comm->is_intercomm;
+    else return ::MPI_Comm_test_inter(to_mpi_comm(comm->mpi_comm), flag);
   }
 
@@ -133,57 +128,4 @@
   }
 
-  int test_sendrecv(MPI_Comm comm)
-  {
-    int myRank;
-    MPI_Comm_rank(comm, &myRank);
-    bool amClient = false;
-    bool amServer = false;
-    if(myRank<=3) amClient = true;
-    else amServer = true;
-
-    if(amServer)
-    {
-      int send_buf[4];
-      MPI_Request send_request[8];
-      MPI_Status send_status[8];
-
-      
-      
-      for(int j=0; j<4; j++)  // 4 buffers
-      {
-        for(int i=0; i<2; i++)
-        {
-          send_buf[j] = (myRank+1)*100 + j;
-          MPI_Isend(&send_buf[j], 1, MPI_INT, i*2, 9999, comm, &send_request[i*4+j]);
-        }
-      }
-      
-
-      MPI_Waitall(8, send_request, send_status);
-    }
-
-
-    if(amClient&&myRank%2==0) // Clients leaders
-    {
-      int recv_buf[8];
-      MPI_Request recv_request[8];
-      MPI_Status recv_status[8];
-
-      for(int i=0; i<2; i++)  // 2 servers
-      {
-        for(int j=0; j<4; j++)
-        {
-          MPI_Irecv(&recv_buf[i*4+j], 1, MPI_INT, i+4, 9999, comm, &recv_request[i*4+j]);
-        }
-      }
-
-      MPI_Waitall(8, recv_request, recv_status);
-      printf("============ client %d, recv_buf = %d, %d, %d, %d, %d, %d, %d, %d ================\n", 
-              myRank, recv_buf[0], recv_buf[1], recv_buf[2], recv_buf[3], recv_buf[4], recv_buf[5], recv_buf[6], recv_buf[7]);
-    }
-
-    MPI_Barrier(comm);
-
-  }
 
   bool valid_type(MPI_Datatype datatype)
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp	(revision 1539)
@@ -4,12 +4,10 @@
 #include "ep_type.hpp"
 #include "ep_lib_intercomm.hpp"
-#include "ep_lib_intracomm.hpp"
+#include "ep_lib_endpoint.hpp"
 #include "ep_lib_local.hpp"
 #include "ep_lib_collective.hpp"
-#include "ep_tag.hpp"
 #include "ep_lib_fortran.hpp"
 #include "ep_lib_win.hpp"
 #include "ep_lib_mpi.hpp"
-//#include "ep_mpi.hpp"
 
 
@@ -41,4 +39,5 @@
   int MPI_Comm_remote_size(MPI_Comm comm, int *size);
 
+
   int MPI_Send(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
   int MPI_Ssend(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
@@ -64,5 +63,4 @@
   
   int MPI_Alloc_mem(MPI_Aint size, MPI_Info info, void *baseptr);
-  
   int MPI_Alloc_mem(unsigned long size, MPI_Info info, void *baseptr);
 
@@ -86,12 +84,7 @@
 
   int test_sendrecv(MPI_Comm comm);
-  
-  int EP_group_init();
 
 
 }
 
-//MPI_Datatype to_mpi(ep_lib::MPI_Datatype type);
-
-
 #endif // EP_LIB_HPP_INCLUDED
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp	(revision 1539)
@@ -10,5 +10,5 @@
 
   int MPI_Barrier(MPI_Comm comm);
-  
+ 
 
   int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm);
@@ -47,10 +47,10 @@
   int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
 
-  int MPI_Intercomm_create_kernel(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
   
   
-  int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, void* peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
   
-  int MPI_Intercomm_create_unique_leader(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+  //int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, void* peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
+  
+  //int MPI_Intercomm_create_unique_leader(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
 
   int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls); // from EP to create endpoints
@@ -60,5 +60,5 @@
   int MPI_Intercomm_merge(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
 
-  int MPI_Intercomm_merge_unique_leader(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
+  //int MPI_Intercomm_merge_unique_leader(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
 
 }
